//
//  main.m
//  PixelStitcher
//
//  Created by Tomas Franzén on 21/04/16.
//  Copyright © 2016 Tomas Franzén. All rights reserved.
//

@import Foundation;
@import CoreGraphics;


int main(int argc, const char * argv[]) {
	@autoreleasepool {
		
		// Fill in these:
		NSURL *imageDirectoryURL = [NSURL fileURLWithPath:@"/Users/tomasf/Desktop/RELOCK"];
		NSURL *bitmapURL = [NSURL fileURLWithPath:@"/Users/tomasf/Desktop/RELOCK_composite.png"];
		NSUInteger maxImageIndex = 49342;
		size_t width = 197;
		
		size_t horizontalOffset = 0;
		size_t height = ceil((maxImageIndex+1)/width);
		
		// Create a bitmap
		CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
		CGContextRef context = CGBitmapContextCreate(NULL, width, height, 8, width * 4, colorSpace, kCGImageAlphaPremultipliedFirst);
		CFRelease(colorSpace);
		
		// ...with a sane coordinate space
		CGContextTranslateCTM(context, 0, height);
		CGContextScaleCTM(context, 1, -1);
		
		// Fill with black. Remove this for transparent pixels
		CGContextSetRGBFillColor(context, 0, 0, 0, 1);
		CGContextFillRect(context, CGRectMake(0, 0, width, height));
		
		// Go through all frames
		for (NSUInteger frame=0; frame <= maxImageIndex; frame++) {
			size_t adjustedIndex = frame + horizontalOffset;
			long x = adjustedIndex % width;
			long y = adjustedIndex / width;
			
			// Read the image file
			NSURL *URL = [imageDirectoryURL URLByAppendingPathComponent:[NSString stringWithFormat:@"%ld.png", (long)frame]];
			CGImageSourceRef source = CGImageSourceCreateWithURL((CFURLRef)URL, nil);
			CGImageRef image = CGImageSourceCreateImageAtIndex(source, 0, nil);
			CFRelease(source);
			
			// Draw it in a single pixel of the bitmap
			CGContextDrawImage(context, CGRectMake(x, y, 1, 1), image);
			CFRelease(image);
			
			if (frame % 1000 == 0) {
				NSLog(@"Frame %ld of %ld: %.1f%%", (long)frame, (long)maxImageIndex, ((double)frame/(maxImageIndex+1))*100);
			}
		}
		
		// Save bitmap to disk
		CGImageDestinationRef destination = CGImageDestinationCreateWithURL((CFURLRef)bitmapURL, kUTTypePNG, 1, nil);
		CGImageDestinationAddImage(destination, CGBitmapContextCreateImage(context), nil);
		CGImageDestinationFinalize(destination);
		CFRelease(destination);
		
		/*
		NSData *data = [NSData dataWithBytes:CGBitmapContextGetData(context) length:width*height*4];
		[data writeToFile:@"/Users/tomasf/Desktop/RELOCK_composite_raw" atomically:NO];
		*/
	}
    return EXIT_SUCCESS;
}
